=== debian/changelog ===
stockfish (7-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release 7 (Closes: #759003)
    - this bug was already fixed in version 6.
  * Bump std-version to 3.9.6, no changes required.
  * Update copyright file.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Jan 2016 19:04:47 +0100
