=== debian/changelog ===
stockfish (8-4) unstable; urgency=medium

  * Fix us of DEB_{BUILD,HOST}_* variables; thanks to
    Helmut Grohne <helmut@subdivi.de>.
  * Home page location updated.

 -- Milan Zamazal <pdm@debian.org>  Wed, 16 May 2018 22:00:21 +0200

stockfish (8-3) unstable; urgency=low

  * Set architecture bits from dpkg-architecture.
  * Patch to exclude -m$(bits) compiler flag; thanks to Sven Joachim.
  * Old unused patches removed.

 -- Milan Zamazal <pdm@debian.org>  Sat, 12 Nov 2016 18:55:54 +0100

stockfish (8-2) unstable; urgency=low

  * Build with ARCH=general-64 by default.

 -- Milan Zamazal <pdm@debian.org>  Thu, 10 Nov 2016 21:05:09 +0100

stockfish (8-1) unstable; urgency=low

  * New upstream version; closes: #843696.
  * Enable parallel build.

 -- Milan Zamazal <pdm@debian.org>  Wed, 09 Nov 2016 19:45:41 +0100

stockfish (7-1) unstable; urgency=medium

  * New maintainer; closes: #835314.
  * Standards 3.9.8 (no real changes).

 -- Milan Zamazal <pdm@debian.org>  Mon, 17 Oct 2016 21:28:24 +0200
