=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: stockfish
 Section: games
 Priority: optional
-Maintainer: Oliver Korff <ok@xynyx.de>
+Maintainer: Milan Zamazal <pdm@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.6
-Homepage: http://www.stockfishchess.com
+Standards-Version: 3.9.8
+Homepage: https://stockfishchess.org
 
 Package: stockfish
 Architecture: any
