=== debian/changelog ===
stockfish (9-1) unstable; urgency=medium

  * New upstream version.
  * Standards 4.1.5 (no real change).
  * Debhelper compatibility level increased to 10.

 -- Milan Zamazal <pdm@debian.org>  Wed, 11 Jul 2018 14:02:55 +0200
