=== debian/rules ===
--- 
+++ 
@@ -90,8 +90,7 @@
 	cd src && rm -rf *.gcda && touch .depend && make clean
 
 override_dh_auto_build:
-#	cd src && make $(TARGET2)
-	dh_auto_build --sourcedirectory=src --parallel -- $(TARGET2)
+	dh_auto_build --sourcedirectory=src -- $(TARGET2)
 
 override_dh_auto_test:
 	$(TESTCMD)
