=== debian/changelog ===
stockfish (11-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:58:55 +0100

stockfish (11-1) unstable; urgency=medium

  * New upstream version.
  * Standards 4.5.0 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Mon, 27 Jan 2020 21:56:03 +0100

stockfish (9-2) unstable; urgency=medium

  * rules: Workaround of a gcc bug causing FTBFS on many architectures
    applied; thanks to Adrian Bunk <bunk@debian.org>; closes: #904139.
  * Standards 4.2.1 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Sat, 08 Sep 2018 21:32:46 +0200
