=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Milan Zamazal <pdm@debian.org>
 Build-Depends: debhelper (>= 10)
-Standards-Version: 4.1.5
+Standards-Version: 4.5.0
 Homepage: https://stockfishchess.org
 
 Package: stockfish
