=== debian/rules ===
--- 
+++ 
@@ -29,6 +29,7 @@
 # no compile on the first shot
 ifneq (,$(findstring powerpc,$(DEB_HOST_ARCH_CPU)))
 TARGET := build ARCH=general-$(DEB_HOST_ARCH_BITS)
+export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
 
 ifneq (,$(findstring s390,$(DEB_HOST_ARCH_CPU)))
@@ -41,20 +42,22 @@
 
 ifneq (,$(findstring mips,$(DEB_HOST_ARCH_CPU)))
 TARGET := profile-build ARCH=general-$(DEB_HOST_ARCH_BITS)
+export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
 
 # Profiling fails due to compiler issues
 ifneq (,$(findstring mipsel,$(DEB_HOST_ARCH_CPU)))
 TARGET := build ARCH=general-$(DEB_HOST_ARCH_BITS)
+export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
 
 ifeq (alpha,$(DEB_HOST_ARCH_CPU))
 TARGET := build ARCH=general-$(DEB_HOST_ARCH_BITS)
 endif
 
-# no compile on the first shot
 ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
 TARGET := build ARCH=general-$(DEB_HOST_ARCH_BITS)
+export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
 
 ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
@@ -67,6 +70,12 @@
 
 ifeq (m68k,$(DEB_HOST_ARCH_CPU))
 TARGET := build ARCH=general-$(DEB_HOST_ARCH_BITS)
+export DEB_LDFLAGS_MAINT_APPEND=-latomic
+endif
+
+ifeq (sh4,$(DEB_HOST_ARCH_CPU))
+TARGET := build ARCH=general-$(DEB_HOST_ARCH_BITS)
+export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
